#!/bin/bash
# 
# Copyright (C) 2007 Technical University of Liberec.  All rights reserved.
#
# Please make a following refer to Flow123d on your project site if you use the program for any purpose,
# especially for academic research:
# Flow123d, Research Centre: Advanced Remedial Technologies, Technical University of Liberec, Czech Republic
#
# This program is free software; you can redistribute it and/or modify it under the terms
# of the GNU General Public License version 3 as published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
# without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with this program; if not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 021110-1307, USA.
#
# $Id: svnversion.sh 824 2010-12-17 15:34:45Z jiri.jenicek $
# $Revision: 824 $
# $LastChangedBy: jiri.jenicek $
# $LastChangedDate: 2010-12-17 16:34:45 +0100 (Fri, 17 Dec 2010) $
#

#set -x

max_rev=0
for f in src/*.cc src/*.cpp include/*.h include/*.hh
do
  rev=`grep '$Revision' $f | sed 's/[^0-9]*\\([0-9]*\\).*/\\1/'` 
  if [ -z "$rev" ]; then rev=0; fi
  if [ "$rev" -gt "$max_rev" ] 
  then
    max_rev="$rev"
  fi
done
echo $max_rev
