/*!
 *
 * Copyright (C) 2007 Technical University of Liberec.  All rights reserved.
 *
 * Please make a following refer to Flow123d on your project site if you use the program for any purpose,
 * especially for academic research:
 * Flow123d, Research Centre: Advanced Remedial Technologies, Technical University of Liberec, Czech Republic
 *
 * This program is free software; you can redistribute it and/or modify it under the terms
 * of the GNU General Public License version 3 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program; if not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 021110-1307, USA.
 *
 *
 * $Id: sys_function_stack.cpp 2021 2013-01-06 17:07:28Z jan.brezina $
 * $Revision: 2021 $
 * $LastChangedBy: jan.brezina $
 * $LastChangedDate: 2013-01-06 18:07:28 +0100 (Sun, 06 Jan 2013) $
 *
 * @file
 * @ingroup system
 * @brief  Implementation of function call stack.
 * @author Jiri Jenicek
 *
 */

#include "sys_function_stack.hh"

namespace flow
{
    ///definition of global variables for stacktrace storage
    std::vector<Trace_helper> * Trace::program_stack; //start with 16 slots for trace, should be enough to avoid reallocation
    int Trace::stack_depth = -1;
}
